@echo off
:: Script a cura di Vito Lattanzi - Gentiluomo Digitale
:: www.gentiluomodigitale.it

:: Verifica se lo script è eseguito come amministratore
openfiles >nul 2>nul
if %errorlevel% neq 0 (
    echo Non sono privilegi amministrativi, riavvio con diritti di amministratore...
    powershell -Command "Start-Process cmd -ArgumentList '/c %~s0' -Verb RunAs"
    exit
)

:: Percorso della chiave di registro per DeferFeatureUpdates
set "regKey=HKLM\SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate"
set "regValue=DeferFeatureUpdates"

:: Verifica se la chiave di registro DeferFeatureUpdates esiste
reg query "%regKey%" >nul 2>nul
if %errorlevel% neq 0 (
    :: Crea la chiave di registro se non esiste
    reg add "%regKey%" /f >nul
)

:: Verifica se il valore "DeferFeatureUpdates" esiste
reg query "%regKey%" /v "%regValue%" >nul 2>nul
if %errorlevel% neq 0 (
    :: Crea il valore DWORD "DeferFeatureUpdates" con il valore 1
    reg add "%regKey%" /v "%regValue%" /t REG_DWORD /d 1 /f >nul
    echo La chiave di registro "DeferFeatureUpdates" e' stata aggiunta con il valore 1.
) else (
    echo La chiave "DeferFeatureUpdates" esiste gia'.
)

:: Aggiungi la verifica e la creazione della chiave DriverSigning
set "driverSigningKey=HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\DriverSigning"
set "driverSigningValue=DriverSigning"

:: Verifica se la chiave di registro DriverSigning esiste
reg query "%driverSigningKey%" >nul 2>nul
if %errorlevel% neq 0 (
    :: Crea la chiave di registro se non esiste
    reg add "%driverSigningKey%" /f >nul
)

:: Verifica se il valore "DriverSigning" esiste
reg query "%driverSigningKey%" /v "%driverSigningValue%" >nul 2>nul
if %errorlevel% neq 0 (
    :: Crea il valore DWORD "DriverSigning" con il valore 2 per forzare driver firmati
    reg add "%driverSigningKey%" /v "%driverSigningValue%" /t REG_DWORD /d 2 /f >nul
    echo La chiave di registro "DriverSigning" e' stata aggiunta con il valore 2 per forzare l'uso di driver firmati.
) else (
    echo La chiave "DriverSigning" esiste gia'.
)

echo La configurazione del registro e' stata completata con successo.
pause
